/*
 * Copyright (c) 2013, Linz Center of Mechatronics GmbH (LCM), web: www.lcm.at
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
 *       the names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * This file is part of X2C. web: x2c.lcm.at
 * $LastChangedRevision: 4463 $
 * $LastChangedDate:: 2026-08-17 13:59:56 +0200#$
 */
/* USERCODE-BEGIN:Description */
/* Description: */
/* USERCODE-END:Description */

package at.lcm.x2c.library.general;

import at.lcm.x2c.core.structure.*;
import at.lcm.bu21.general.dtypes.*;

/* USERCODE-BEGIN:Imports */
import at.lcm.x2c.utils.QFormat;
/* USERCODE-END:Imports */

@SuppressWarnings("unused")
public class ConvFnc_Sin3Gen_FiP16 extends JavaConversionFunction {
    private static final long serialVersionUID = 1L;

    @Override
    public void convertMaskToImplementation() throws Exception {
        MaskDouble fmaxMaskVal = (MaskDouble)this.getMaskParameter("fmax").getMaskDataType();
        TNumeric fmaxMaskData = (TNumeric)fmaxMaskVal.getData();
        double mp_fmax = fmaxMaskData.getReal(0, 0);
        MaskDouble OffsetMaskVal = (MaskDouble)this.getMaskParameter("Offset").getMaskDataType();
        TNumeric OffsetMaskData = (TNumeric)OffsetMaskVal.getData();
        double mp_Offset = OffsetMaskData.getReal(0, 0);
        MaskDouble ts_factMaskVal = (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
        TNumeric ts_factMaskData = (TNumeric)ts_factMaskVal.getData();
        double mp_ts_fact = ts_factMaskData.getReal(0, 0);

        TNumeric delta_phiCtrVal = this.getImplementationParameterData("delta_phi");
        double cp_delta_phi = Double.NaN;
        TNumeric offsetCtrVal = this.getImplementationParameterData("offset");
        double cp_offset = Double.NaN;

        /* Check if sample time factor is an integer value */
        if (Math.rint(mp_ts_fact) != mp_ts_fact) {
            throw new Exception("Sample time factor must be a whole number");
        }
        /* Check if sample time factor is within the valid range (upper limit defined by unsigned 16-bit integer range) */
        if ((mp_ts_fact < 1.0) || (mp_ts_fact > 65535.0)) {
            throw new Exception("Sample time factor must be at least 1 and at most 65535");
        }
        /* Block sample time */
        double bp_ts = mp_ts_fact * this.getDedicatedBlock().getModel().getSampleTime();
        /* Check if Block sample time has a valid value */
        if (bp_ts <= 0.0) {
            throw new Exception("Block sample time must be greater than zero");
        }

        /* ATTENTION: */
        /* The M2I conversion function may either use the mp_* or *MaskVal value to get the Mask Parameter value */
        /* For new or updated implementations, the mp_* value shall be used where possible */
        /* Currently, the mp_* value cannot be used for getting non-scalar Mask Parameter data but will return only the first element for these */
        /* The Implementation Parameter assignment variables cp_* can and shall be used for all Implementation Parameter data types */

        /* INFO: Implementation data assignment for array types when using the cp_* variables */
        /* If the cp_* parameter is a FLASH ARRAY, the cp_* variable is assigned an array type but without an actual array */
        /* The M2I conversion function has to assign an array with the correct size and fill it with content */
        /* If the cp_* parameter is a RAM ARRAY, the cp_* variable is assigned an array with the correct size */
        /* The first element is assigned an invalid value while the other elements are (auto)initialized with zero */
        /* The M2I conversion function has to fill the array with content */

        /* Mask parameter values */
        /* mp_fmax OR fmaxMaskVal (Number) */
        /* mp_Offset OR OffsetMaskVal (Number) */
        /* mp_ts_fact OR ts_factMaskVal (Number) */

        /* USERCODE-BEGIN:ConvMaskToImplementation */
		double fmax, Offset;
		int ts_fact;
		double Ts = 0;
		final int BITS = 16;

		// get controller parameter values
		ts_fact = Double.valueOf(ts_factMaskVal.getValue()).intValue();
		fmax = Double.valueOf(fmaxMaskVal.getValue());
		Offset = Double.valueOf(OffsetMaskVal.getValue());

		// validate controller parameters
		if (ts_fact <= 0){
			ts_fact = 1;
		}
		fmax = Math.abs(fmax);

		// sample time
		Ts = ts_fact * this.getDedicatedBlock().getModel().getSampleTime();

		offsetCtrVal.setReal(0, 0, Double.valueOf(QFormat.getQValue(Offset, BITS - 1, BITS, true)));
		delta_phiCtrVal.setReal(0,0, Double.valueOf(QFormat.getQValue(2*Ts*fmax, BITS-1, BITS,true)));	// Ts*fmax has to be smaller than 0.5 (Nyquist criteria)!, otherwise limitation to 0.5

        /* USERCODE-END:ConvMaskToImplementation */

        /* Implementation Parameter values */
        /* cp_delta_phi OR delta_phiCtrVal (Value) */
        /* cp_offset OR offsetCtrVal (Value) */

        if (Double.isNaN(cp_delta_phi)) {
            this.setImplementationParameterData("delta_phi", delta_phiCtrVal);
        } else {
            this.setImplementationParameterData("delta_phi", new TNumeric(cp_delta_phi));
        }
        if (Double.isNaN(cp_offset)) {
            this.setImplementationParameterData("offset", offsetCtrVal);
        } else {
            this.setImplementationParameterData("offset", new TNumeric(cp_offset));
        }
    }

    @Override
    public void convertImplementationToMask() throws Exception {
        MaskDouble fmaxMaskVal = (MaskDouble)this.getMaskParameter("fmax").getMaskDataType();
        TNumeric fmaxMaskData = (TNumeric)fmaxMaskVal.getData();
        double mp_fmax = Double.NaN;
        MaskDouble OffsetMaskVal = (MaskDouble)this.getMaskParameter("Offset").getMaskDataType();
        TNumeric OffsetMaskData = (TNumeric)OffsetMaskVal.getData();
        double mp_Offset = Double.NaN;
        MaskDouble ts_factMaskVal = (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
        TNumeric ts_factMaskData = (TNumeric)ts_factMaskVal.getData();
        double mp_ts_fact = ts_factMaskData.getReal(0, 0);

        TNumeric delta_phiCtrVal = this.getImplementationParameterData("delta_phi");
        double cp_delta_phi = delta_phiCtrVal.getReal(0, 0);
        TNumeric offsetCtrVal = this.getImplementationParameterData("offset");
        double cp_offset = offsetCtrVal.getReal(0, 0);

        /* Check if sample time factor is an integer value */
        if (Math.rint(mp_ts_fact) != mp_ts_fact) {
            throw new Exception("Sample time factor must be a whole number");
        }
        /* Check if sample time factor is within the valid range (upper limit defined by unsigned 16-bit integer range) */
        if ((mp_ts_fact < 1.0) || (mp_ts_fact > 65535.0)) {
            throw new Exception("Sample time factor must be at least 1 and at most 65535");
        }
        /* Block sample time */
        double bp_ts = mp_ts_fact * this.getDedicatedBlock().getModel().getSampleTime();
        /* Check if Block sample time has a valid value */
        if (bp_ts <= 0.0) {
            throw new Exception("Block sample time must be greater than zero");
        }

        /* ATTENTION: */
        /* The I2M conversion function may either use the cp_* or *CtrlVal value to get the Implementation Parameter value */
        /* For new or updated implementations, the cp_* value shall be used for all Implementation Parameter data types */
        /* The Mask Parameter assignment variables cp_* shall be used where possible */
        /* Currently, the mp_* variable assignment value cannot be used for setting non-scalar Mask Parameter data */

        /* Implementation Parameter values */
        /* cp_delta_phi OR delta_phiCtrVal (Value) */
        /* cp_offset OR offsetCtrVal (Value) */

        /* USERCODE-BEGIN:ConvImplementationToMask */
		double Ts = 0;
		int ts_fact;
		double Offset, fmax, delta_phi;
		final int BITS = 16;

		// get controller parameter
		delta_phi = delta_phiCtrVal.getReal(0, 0);
		Offset = offsetCtrVal.getReal(0, 0);

		// get sample time information from model (sample time information can't be obtained from target)
		ts_fact = Double.valueOf(ts_factMaskVal.getValue()).intValue();
		Ts = ts_fact * this.getDedicatedBlock().getModel().getSampleTime();

		// calculate mask parameter
		delta_phi = QFormat.getDecValue((long) delta_phi, BITS - 1, BITS, true);
		fmax = delta_phi / (2 * Ts);
		Offset = QFormat.getDecValue((long) Offset, BITS - 1, BITS, true);

		// set mask parameter
		fmaxMaskData.setReal(0, 0, fmax);
		OffsetMaskData.setReal(0, 0, Offset);

        /* USERCODE-END:ConvImplementationToMask */

        /* Mask parameter values */
        /* mp_fmax OR fmaxMaskVal (Number) */
        /* mp_Offset OR OffsetMaskVal (Number) */
        /* mp_ts_fact OR ts_factMaskVal (Number) */

        if (Double.isNaN(mp_fmax)) {
            this.getMaskParameter("fmax").setValue(fmaxMaskData.toFullString());
        } else {
            this.getMaskParameter("fmax").setValue(new TNumeric(mp_fmax).toFullString());
        }
        if (Double.isNaN(mp_Offset)) {
            this.getMaskParameter("Offset").setValue(OffsetMaskData.toFullString());
        } else {
            this.getMaskParameter("Offset").setValue(new TNumeric(mp_Offset).toFullString());
        }
    }
}
